#!/bin/sh
# Oxygen Startup script
# (c) 2006 Syncro Soft Ltd.

oldpwd=`pwd`

# Resolve the location of the oxygen installation.
# This includes resolving any symlinks.
PRG=$0
cd "`dirname "$PRG"`"
PRG=`basename "$PRG"`

while [ -L "$PRG" ]
do
	PRG="`readlink "$PRG"`"
	cd "`dirname "$PRG"`"
	PRG="`basename "$PRG"`"
done

OXYGEN_HOME=`dirname "$PRG"`

# Absolutize dir
cd "${OXYGEN_HOME}"; OXYGEN_HOME=`pwd`
cd "${oldpwd}"; unset oldpwd

# Classpath
CP=$OXYGEN_HOME/lib/oxygen.jar:$OXYGEN_HOME/lib/author.jar:$OXYGEN_HOME/lib/syncroSVNClient.jar:$OXYGEN_HOME/classes:$OXYGEN_HOME

#  The two command line parameters are optional and represent the path of the file 
#  displayed in the left side panel of the XML Diff window and the path of the file 
#  displayed in the right side panel.
java -Xdock:name=DiffFiles\
 -Xdock:icon="$OXYGEN_HOME/DiffFiles.app/Contents/Resources/DiffFiles.icns"\
 -Dcom.oxygenxml.app.descriptor=ro.sync.diff.ui.DiffFilesMainFrameDescriptor\
 -Xmx512m\
 -XX:SoftRefLRUPolicyMSPerMB=10\
 -cp "$CP"\
 ro.sync.exml.Oxygen "$1" "$2"