#!/bin/sh
# Oxygen Startup script
# (c) 2006 Syncro Soft Ltd.

oldpwd=`pwd`

# Resolve the location of the oxygen installation.
# This includes resolving any symlinks.
PRG=$0
cd "`dirname "$PRG"`"
PRG=`basename "$PRG"`

while [ -L "$PRG" ]
do
	PRG="`readlink "$PRG"`"
	cd "`dirname "$PRG"`"
	PRG="`basename "$PRG"`"
done

OXYGEN_HOME=`dirname "$PRG"`

# Absolutize dir
cd "${OXYGEN_HOME}"; OXYGEN_HOME=`pwd`
cd "${oldpwd}"; unset oldpwd

# Classpath
CP=$OXYGEN_HOME/lib/oxygen.jar:$OXYGEN_HOME/classes:$OXYGEN_HOME

#
# The command line parameter is optional and represents the path of a file
# opened automatically at startup
#
# To make the tree editor readonly, change the 
# "com.oxygenxml.tree.readonly" property to true
#
java -Xdock:name=Oxygen\
 -Xdock:icon="$OXYGEN_HOME/TreeEditor.app/Contents/Resources/TreeEditor.icns"\
 -Dcom.oxygenxml.app.descriptor=ro.sync.ui.tree.TreeMainEditorDescriptor \
 -Dcom.oxygenxml.tree.readonly=false\
 -Xmx512m\
 -XX:SoftRefLRUPolicyMSPerMB=10\
 -cp "$CP"\
 ro.sync.exml.Oxygen "$1"