#!/bin/sh
# Oxygen Startup script
# (c) 2006 Syncro Soft Ltd.

oldpwd=`pwd`

# Resolve the location of the oxygen installation.
# This includes resolving any symlinks.
PRG=$0
cd "`dirname "$PRG"`"
PRG=`basename "$PRG"`

while [ -L "$PRG" ]
do
	PRG="`readlink "$PRG"`"
	cd "`dirname "$PRG"`"
	PRG="`basename "$PRG"`"
done

OXYGEN_HOME=`dirname "$PRG"`

# Absolutize dir
cd "${OXYGEN_HOME}"; OXYGEN_HOME=`pwd`
cd "${oldpwd}"; unset oldpwd

# Classpath
CP=$OXYGEN_HOME/lib/log4j.jar:$OXYGEN_HOME/lib/oxygen.jar:$OXYGEN_HOME/classes:$OXYGEN_HOME:$OXYGEN_HOME/lib/xercesImpl.jar:$OXYGEN_HOME/lib/resolver.jar

java \
 -Xmx512m\
 -XX:SoftRefLRUPolicyMSPerMB=10\
 -XX:MaxPermSize=256m\
 -cp "$CP"\
 ro.sync.xml.generator.XMLInstanceGenerator "$@"